/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_REG                                                      */
/* Tabela : REGIAO                                                            */
/*                                                                            */
/* Criao:                                                                   */
/* 10/07/2000 - Joo Fernando dos Reis Corra                                 */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_REG
BEFORE INSERT OR UPDATE OR DELETE
ON REGIAO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUREG := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDREGIAO,0) <> NVL(:NEW.CDREGIAO,0)) OR
         (NVL(:OLD.NMREGIAO,0) <> NVL(:NEW.NMREGIAO,0)) THEN
         :NEW.DTULTATUREG := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('REGIAO', '', 'CDREGIAO='||:OLD.CDREGIAO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE REGIAO MODIFY DTULTATUREG DEFAULT SYSDATE
/
